# IRiKeying Interface Reference

Inherits IDispatch.

List of all members.

## Public Member Functions
HRESULT | AddAttribute ([in] BSTR bszKeyingTemplate,[in] BSTR bszAttribute)
HRESULT | RemoveAttribute ([in] BSTR bszKeyingTemplate,[in] BSTR bszAttribute)
HRESULT | BrowseAttributes ([in] BSTR bszKeyingTemplate,[in] BSTR bszObjectName)
HRESULT | OpenView (void)
HRESULT | Interpolation ([in]BSTR bszInterpolationType)
HRESULT | BezierSharpness ([in] VARIANT vSharpnessValue)
HRESULT | BezierSharpnessLeft ([in] VARIANT vLeftSharpnessValue)
HRESULT | BezierSharpnessRight ([in] VARIANT vRightSharpnessValue)
HRESULT | BezierTangentAngle ([in] VARIANT vAngleValue)
HRESULT | BezierTangentAngleLeft ([in] VARIANT vAngleValue)
HRESULT | BezierTangentAngleRight ([in] VARIANT vAngleValue)
HRESULT | ResetKeyingTemplate ([in] BSTR bszKeyingTemplate)

## Detailed Description

The IRiKeying interface provides access to keying properties, keying template and interpolation types.
Root-level name in the scripting engine's name space: RsAnimKeying .

## Member Function Documentation

HRESULT IRiKeying::AddAttribute | ( | [in] BSTR | bszKeyingTemplate,
|  | [in] BSTR | bszAttribute |
| ) |  |  |

Adds new attribute to keying template.

Parameters:

  `[in]` | bszKeyingTemplate | Identification of keying template. If left blank, current keying template is used. Otherwise use full path to keying template. Path is local to System/AnimMng, which encapsulates available templates.
  `[in]` | bszAttribute | Full name of attribute, relative to animation space.

        var owner = System.ThisOwner();
        var target = owner + '/Cube';
        var targetAttr = 'Depth';
        RsAnimKeying.AddAttribute('',targetAttr);

HRESULT IRiKeying::RemoveAttribute | ( | [in] BSTR | bszKeyingTemplate,
|  | [in] BSTR | bszAttribute |
| ) |  |  |

Removes attribute from keying template.

Parameters:

  `[in]` | bszKeyingTemplate | Identification of keying template.
  `[in]` | bszAttribute | Name of attribute, relative to animation space.

        RsAnimKeying.RemoveAttribute('',targetAttr);

HRESULT IRiKeying::BrowseAttributes | ( | [in] BSTR | bszKeyingTemplate,
|  | [in] BSTR | bszObjectName |
| ) |  |  |

Open browser for attributes. Selected attributes are added to keying template.

Parameters:

  `[in]` | bszKeyingTemplate | Identification of keying template.
  `[in]` | bszObjectName | Name of object which is used as template for attribute browser.

        RsAnimKeying.BrowseAttributes('',target);

HRESULT IRiKeying::OpenView | ( | void |  | ) |

Opens keying panel.

        RsAnimKeying.OpenView();

HRESULT IRiKeying::Interpolation | ( | [in] BSTR | bszInterpolationType | ) |

Sets interpolation type for selected keyframes.

Parameters:

  `[in]` | bszInterpolationType | Interpolation type. It can be one of the following: bezier linear constantmax constantmin custom
          RsAnimKeying.Interpolation('linear');
          or
          RsAnimKeying.Interpolation('bezier');

HRESULT IRiKeying::BezierSharpness | ( | [in] VARIANT | vSharpnessValue | ) |

Sets left and right bezier sharpness parameters for selected keyframes.

Parameters:

  `[in]` | vSharpnessValue | New sharpness value.

        RsAnimKeying.BezierSharpness(0.50);

HRESULT IRiKeying::BezierSharpnessLeft | ( | [in] VARIANT | vLeftSharpnessValue | ) |

Sets left bezier sharpness parameter for selected keyframes.

Parameters:

  `[in]` | vLeftSharpnessValue | New left sharpness value.

        RsAnimKeying.BezierSharpnessLeft(0.70);

HRESULT IRiKeying::BezierSharpnessRight | ( | [in] VARIANT | vRightSharpnessValue | ) |

Sets right bezier sharpness parameter for selected keyframes.

Parameters:

  `[in]` | vRightSharpnessValue | New right sharpness value.

        RsAnimKeying.BezierSharpnessRight(0.65);

HRESULT IRiKeying::BezierTangentAngle | ( | [in] VARIANT | vAngleValue | ) |

Sets left and right bezier tangent angle parameters for selected keyframes.
Set Interpolation to Custom Bezier while monitoring selected keyframe(s) in FCurve view.
Added numerical queue added to FCurve view to right of sharpness values.

Parameters:

  `[in]` | vAngleValue | New value.

        RsAnimKeying.BezierTangentAngle(45);

HRESULT IRiKeying::BezierTangentAngleLeft | ( | [in] VARIANT | vAngleValue | ) |

Sets left bezier tangent angle parameters for selected keyframes.

Parameters:

  `[in]` | vAngleValue | New value.

        RsAnimKeying.BezierTangentAngleLeft(55);

HRESULT IRiKeying::BezierTangentAngleRight | ( | [in] VARIANT | vAngleValue | ) |

Sets right bezier tangent angle parameters for selected keyframes

Parameters:

  `[in]` | vAngleValue | New value.

        RsAnimKeying.BezierTangentAngleRight(25);

HRESULT IRiKeying::ResetKeyingTemplate | ( | [in] BSTR | bszKeyingTemplate | ) |

Resets keying template.

Parameters:

  `[in]` | bszKeyingTemplate | Identification of keying template.

        RsAnimKeying.ResetKeyingTemplate(target);